MantisBT
Mantis Bug Tracker Workflow

View Issue Details Jump to Notes ] Related Changesets ] Issue History ] Print ]
IDProjectCategoryView StatusDate SubmittedLast Update
0029519Open CASCADE[OCCT] OCCT:Visualizationpublic2018-02-20 07:442018-06-29 21:21
Reporterkgv 
Assigned Tobugmaster 
PrioritynormalSeveritytrivial 
StatusclosedResolutionfixed 
PlatformOSOS Version
Product Version[OCCT] 6.8.0 
Target Version[OCCT] 7.3.0Fixed in Version[OCCT] 7.3.0 
Summary0029519: Visualization, TKOpenGl - fallback to Graphic3d_TOSM_FACET from Gouraud/Phong when nodal normals are undefined
DescriptionIn previous OCCT versions, Primitive Array of triangles without normal vertex attributes have been treated implicitly as no Shading (lighting) should be done.

Introduction of explicit Shading Model within each Fill Area aspect by 0029097 makes this behavior less obvious, because it is expected now that Shading should be explicitly disabled by specifying Graphic3d_TOSM_UNLIT.

Moreover, Graphic3d_TOSM_FACET is treated specifically and ignores missing normal attributes (since normal attributes are not required for this Shading Model, and sparing vertex attributes is one of the benefit of using it).

It is proposed unifying behavior, so that Graphic3d_TOSM_VERTEX and Graphic3d_TOSM_FRAGMENT will fallback to Graphic3d_TOSM_FACET instead of Graphic3d_TOSM_UNLIT when no normal attributes are defined for triangles array. As result, user should specify explicitly Graphic3d_TOSM_UNLIT Shading Model or material without reflecting properties to preserve old behavior.
Steps To Reproducebugs vis bug26028

pload ALL
vclear
vinit View1
meshfromstl m2 [locate_data_file data/stl/bearing.stl]
meshcolors m2 elem2 0
vbottom
vfit

Bug: the back side of a mesh presentation should be RED, but it is BLUE as front side.
TagsNo tags attached.
Test case numberNot needed
Attached Files

- Relationships
related to 0029097closedbugmaster Visualization - allow picking Graphic3d_TypeOfShadingModel per-object 

-  Notes
(0074061)
git (administrator)
2018-02-20 08:00

Branch CR29519 has been created by kgv.

SHA-1: 9d7d096a23ad066f9f2887c0d7ef3997f4c89967


Detailed log of new commits:

Author: kgv
Date: Tue Feb 20 08:00:01 2018 +0300

    0029519: Visualization, TKOpenGl - fallback to Graphic3d_TOSM_FACET from Gouraud/Phong when nodal normals are undefined
(0074092)
git (administrator)
2018-02-21 17:29

Branch CR29519 has been updated forcibly by kgv.

SHA-1: 62d01cc8a8b9f511ed471c318ac40b80a3968d0c
(0074109)
kgv (developer)
2018-02-22 11:58

Please take the patch.

http://jenkins-test-10.nnov.opencascade.com:8080//view/CR29519-CR29519-KGV [^]
(0074115)
bugmaster (administrator)
2018-02-22 13:23

Combination -
OCCT branch : CR29519 SHA - 62d01cc8a8b9f511ed471c318ac40b80a3968d0c
Products branch : CR29519 SHA - 14347aa3a6996e51ea01a4dbb023f668af5ac3a3
was compiled on Linux, MacOS and Windows platforms and tested in optimize mode.

Number of compiler warnings:
No new/fixed warnings

Regressions/Differences/Improvements:
No regressions/differences

CPU differences:
Debian70-64:
OCCT
Total CPU difference: 18238.949999999622 / 18347.729999999596 [-0.59%]
Products
Total CPU difference: 7469.459999999996 / 7469.6700000000055 [-0.00%]
Windows-64-VC10:
OCCT
Total CPU difference: 17694.5226256986 / 17722.010001898587 [-0.16%]
Products
Total CPU difference: 8008.919738899983 / 8043.3491595999785 [-0.43%]


Image differences :
No differences that require special attention

Memory differences :
No differences that require special attention
(0074116)
kgv (developer)
2018-02-22 13:31

> 2018-02-22 13:23 bugmaster Test case number => Not needed
bugs/vis/bug26028 could be specified (requires visual check).
(0074297)
git (administrator)
2018-03-06 15:50

Branch CR29519 has been deleted by kgv.

SHA-1: 62d01cc8a8b9f511ed471c318ac40b80a3968d0c

- Related Changesets
occt: master db5d29de
Timestamp: 2018-02-20 05:00:01
Author: kgv
Committer: bugmaster
Details ] Diff ]
0029519: Visualization, TKOpenGl - fallback to Graphic3d_TOSM_FACET from Gouraud/Phong when nodal normals are undefined
mod - dox/dev_guides/upgrade/upgrade.md Diff ] File ]
mod - src/OpenGl/OpenGl_PrimitiveArray.cxx Diff ] File ]
mod - src/OpenGl/OpenGl_ShaderManager.hxx Diff ] File ]

- Issue History
Date Modified Username Field Change
2018-02-20 07:44 kgv New Issue
2018-02-20 07:44 kgv Assigned To => kgv
2018-02-20 07:44 kgv Relationship added related to 0029097
2018-02-20 07:46 kgv Summary Visualization, TKOpenGl - fallback to Graphic3d_TOSM_FACET when nodal normals are undefined => Visualization, TKOpenGl - fallback to Graphic3d_TOSM_FACET from Gouraud/Phong when nodal normals are undefined
2018-02-20 08:00 git Note Added: 0074061
2018-02-21 17:29 git Note Added: 0074092
2018-02-22 10:29 kgv Severity integration request => trivial
2018-02-22 10:29 kgv Product Version => 6.8.0
2018-02-22 10:29 kgv Steps to Reproduce Updated View Revisions
2018-02-22 11:58 kgv Note Added: 0074109
2018-02-22 11:58 kgv Assigned To kgv => bugmaster
2018-02-22 11:58 kgv Status new => resolved
2018-02-22 11:59 kgv Status resolved => reviewed
2018-02-22 13:23 bugmaster Note Added: 0074115
2018-02-22 13:23 bugmaster Status reviewed => tested
2018-02-22 13:23 bugmaster Test case number => Not needed
2018-02-22 13:31 kgv Note Added: 0074116
2018-03-04 15:34 bugmaster Changeset attached => occt master db5d29de
2018-03-04 15:34 bugmaster Status tested => verified
2018-03-04 15:34 bugmaster Resolution open => fixed
2018-03-06 15:50 git Note Added: 0074297
2018-06-29 21:16 user533 Fixed in Version => 7.3.0
2018-06-29 21:21 user533 Status verified => closed


Copyright © 2000 - 2018 MantisBT Team
Powered by Mantis Bugtracker